#include <Arduino.h>

#include "bma456_node.h"  // accelerometer

// Variables
BMA456 bma456;

uint int_flag = 0;

#define INT1 0x01 // Tap
#define INT2 0x02 // FIFO and data ready

void IRAM_ATTR isr1()
{
    int_flag |= INT1;
}
void IRAM_ATTR isr2()
{
    int_flag |= INT2;
}

void setup()
{
    Serial.begin(115200);
    Serial.printf("BMA456 Test");

    bma456.init(PIN_ACC_CLK, PIN_ACC_MISO, PIN_ACC_MOSI, PIN_ACC_CS, PIN_ACC_INT1, PIN_ACC_INT2);

    // bma456.tapDetector();
    log_d("Interrupt tap detector");

    // BMA456H_TAP_OUT_INT
    pinMode(PIN_ACC_INT1, INPUT_PULLDOWN);
    pinMode(PIN_ACC_INT2, INPUT_PULLDOWN);

    attachInterrupt(PIN_ACC_INT1, isr1, RISING);
    attachInterrupt(PIN_ACC_INT2, isr2, RISING);
}

void loop()
{
    if (int_flag & INT1)
    {
        int_flag &= ~INT1;
        log_w("Taps: %u", bma456.readIntStatus());
    }

    if (int_flag & INT2)
    {
        log_w("INT2 Triggered");
        int_flag &= ~INT2;
    }
}